// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import axios from 'axios';
import { Cookies } from 'react-cookie';
import cookie from 'cookie';
import moment from 'moment';
import jwt from 'jsonwebtoken';
import { cors } from '../../../lib/cors';

export default async function handler(req, res) 
{
	await cors(req, res);

	if(req.headers.cookie !== undefined)
	{
		const cookies = cookie.parse(req.headers?.cookie ? req.headers?.cookie : "");

		if(cookies.jwt !== undefined && cookies.jwt !== null)
		{
			var client_jwt_decoded = jwt.verify(cookies.jwt, process.env.JWT_SECRET_CLIENT);
			var crm_jwt = jwt.sign(client_jwt_decoded, process.env.JWT_SECRET_CRM, { noTimestamp: true });

			try
			{
				axios.get(`${ process.env.CRM_API_HOST }/file/GetFile/`, {
					params: { ...client_jwt_decoded, id: req.query.id }, 
					responseType: 'arraybuffer',
					headers: {
						"Authorization": `Bearer ${ crm_jwt }`, 
					} 
				})
				.then((crm_response) => 
				{
					console.log("GET FILE crm_response");
					for(let i in crm_response)
					{
						if(i !== "data")
						{
							console.log(i);
							console.log(crm_response[i]);
							console.log(".".repeat(50));
						}
					}
					console.log("-".repeat(50));

					res.status(200).send(crm_response.data);
				})
				.catch((error) => 
				{
					console.error(error);
					res.status(500);
				});
			}
			catch(e)
			{
				console.error(e);
				res.status(500);
			}
		}
		else
		{
			res.status(403);
		}
	}
}